/* contacts-avatar-menu.c generated by valac 0.15.0.63-4c098, the Vala compiler
 * generated from contacts-avatar-menu.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 8 -*- */
/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <libgnome-desktop/gnome-desktop-thumbnail.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <folks/folks.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gee.h>


#define CONTACTS_TYPE_AVATAR_MENU (contacts_avatar_menu_get_type ())
#define CONTACTS_AVATAR_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_AVATAR_MENU, ContactsAvatarMenu))
#define CONTACTS_AVATAR_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_AVATAR_MENU, ContactsAvatarMenuClass))
#define CONTACTS_IS_AVATAR_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_AVATAR_MENU))
#define CONTACTS_IS_AVATAR_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_AVATAR_MENU))
#define CONTACTS_AVATAR_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_AVATAR_MENU, ContactsAvatarMenuClass))

typedef struct _ContactsAvatarMenu ContactsAvatarMenu;
typedef struct _ContactsAvatarMenuClass ContactsAvatarMenuClass;
typedef struct _ContactsAvatarMenuPrivate ContactsAvatarMenuPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block27Data Block27Data;

#define CONTACTS_TYPE_CONTACT (contacts_contact_get_type ())
#define CONTACTS_CONTACT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_CONTACT, ContactsContact))
#define CONTACTS_CONTACT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_CONTACT, ContactsContactClass))
#define CONTACTS_IS_CONTACT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_CONTACT))
#define CONTACTS_IS_CONTACT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_CONTACT))
#define CONTACTS_CONTACT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_CONTACT, ContactsContactClass))

typedef struct _ContactsContact ContactsContact;
typedef struct _ContactsContactClass ContactsContactClass;
typedef struct _ContactsContactPrivate ContactsContactPrivate;

#define CONTACTS_TYPE_STORE (contacts_store_get_type ())
#define CONTACTS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_STORE, ContactsStore))
#define CONTACTS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_STORE, ContactsStoreClass))
#define CONTACTS_IS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_STORE))
#define CONTACTS_IS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_STORE))
#define CONTACTS_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_STORE, ContactsStoreClass))

typedef struct _ContactsStore ContactsStore;
typedef struct _ContactsStoreClass ContactsStoreClass;
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))

struct _ContactsAvatarMenu {
	GtkMenu parent_instance;
	ContactsAvatarMenuPrivate * priv;
};

struct _ContactsAvatarMenuClass {
	GtkMenuClass parent_class;
};

struct _ContactsAvatarMenuPrivate {
	GnomeDesktopThumbnailFactory* thumbnail_factory;
};

struct _Block27Data {
	int _ref_count_;
	ContactsAvatarMenu * self;
	GtkFileChooserDialog* chooser;
};

struct _ContactsContact {
	GObject parent_instance;
	ContactsContactPrivate * priv;
	ContactsStore* store;
	gboolean is_primary;
	FolksPresenceType presence_type;
	gchar* presence_message;
	gboolean is_phone;
	FolksIndividual* individual;
};

struct _ContactsContactClass {
	GObjectClass parent_class;
};


static gpointer contacts_avatar_menu_parent_class = NULL;

GType contacts_avatar_menu_get_type (void) G_GNUC_CONST;
#define CONTACTS_AVATAR_MENU_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CONTACTS_TYPE_AVATAR_MENU, ContactsAvatarMenuPrivate))
enum  {
	CONTACTS_AVATAR_MENU_DUMMY_PROPERTY
};
static GtkMenuItem* contacts_avatar_menu_menu_item_for_pixbuf (ContactsAvatarMenu* self, GdkPixbuf* pixbuf, GIcon* icon);
GdkPixbuf* contacts_contact_frame_icon (GdkPixbuf* icon);
static GtkMenuItem* contacts_avatar_menu_menu_item_for_persona (ContactsAvatarMenu* self, FolksPersona* persona);
static GtkMenuItem* contacts_avatar_menu_menu_item_for_filename (ContactsAvatarMenu* self, const gchar* filename);
static void contacts_avatar_menu_set_avatar_from_icon (ContactsAvatarMenu* self, GIcon* icon);
static void contacts_avatar_menu_pick_avatar_cb (ContactsAvatarMenu* self, GtkMenuItem* menu);
void contacts_avatar_menu_update_preview (ContactsAvatarMenu* self, GtkFileChooser* chooser);
static void contacts_avatar_menu_select_avatar_file_cb (ContactsAvatarMenu* self, GtkMenuItem* menu);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (Block27Data* _data27_);
static void _contacts_avatar_menu_update_preview_gtk_file_chooser_update_preview (GtkFileChooser* _sender, gpointer self);
static void __lambda32_ (Block27Data* _data27_, gint response);
static void ___lambda32__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self);
GType contacts_contact_get_type (void) G_GNUC_CONST;
ContactsAvatarMenu* contacts_avatar_menu_new (ContactsContact* contact);
ContactsAvatarMenu* contacts_avatar_menu_construct (GType object_type, ContactsContact* contact);
GType contacts_store_get_type (void) G_GNUC_CONST;
static void _contacts_avatar_menu_pick_avatar_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static gchar** _vala_array_dup5 (gchar** self, int length);
GtkMenuItem* contacts_utils_add_menu_item (GtkMenu* menu, const gchar* label);
static void _contacts_avatar_menu_select_avatar_file_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void contacts_avatar_menu_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GtkMenuItem* contacts_avatar_menu_menu_item_for_pixbuf (ContactsAvatarMenu* self, GdkPixbuf* pixbuf, GIcon* icon) {
	GtkMenuItem* result = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* image;
	GtkMenuItem* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* menuitem;
	GtkMenuItem* _tmp9_;
	GtkImage* _tmp10_;
	GtkMenuItem* _tmp11_;
	GtkMenuItem* _tmp12_;
	GIcon* _tmp13_;
	GIcon* _tmp14_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (icon != NULL, NULL);
	_tmp0_ = pixbuf;
	if (_tmp0_ == NULL) {
		result = NULL;
		return result;
	}
	_tmp1_ = pixbuf;
	_tmp2_ = contacts_contact_frame_icon (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp3_);
	_tmp5_ = g_object_ref_sink (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp3_);
	image = _tmp6_;
	_tmp7_ = (GtkMenuItem*) gtk_menu_item_new ();
	_tmp8_ = g_object_ref_sink (_tmp7_);
	menuitem = _tmp8_;
	_tmp9_ = menuitem;
	_tmp10_ = image;
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
	_tmp11_ = menuitem;
	gtk_widget_show_all ((GtkWidget*) _tmp11_);
	_tmp12_ = menuitem;
	_tmp13_ = icon;
	_tmp14_ = _g_object_ref0 (_tmp13_);
	g_object_set_data_full ((GObject*) _tmp12_, "source-icon", _tmp14_, g_object_unref);
	result = menuitem;
	_g_object_unref0 (image);
	return result;
}


static GtkMenuItem* contacts_avatar_menu_menu_item_for_persona (ContactsAvatarMenu* self, FolksPersona* persona) {
	GtkMenuItem* result = NULL;
	FolksPersona* _tmp0_;
	FolksAvatarDetails* _tmp1_;
	FolksAvatarDetails* details;
	gboolean _tmp2_ = FALSE;
	FolksAvatarDetails* _tmp3_;
	gboolean _tmp7_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (persona != NULL, NULL);
	_tmp0_ = persona;
	_tmp1_ = _g_object_ref0 (FOLKS_IS_AVATAR_DETAILS (_tmp0_) ? ((FolksAvatarDetails*) _tmp0_) : NULL);
	details = _tmp1_;
	_tmp3_ = details;
	if (_tmp3_ == NULL) {
		_tmp2_ = TRUE;
	} else {
		FolksAvatarDetails* _tmp4_;
		GLoadableIcon* _tmp5_;
		GLoadableIcon* _tmp6_;
		_tmp4_ = details;
		_tmp5_ = folks_avatar_details_get_avatar (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp2_ = _tmp6_ == NULL;
	}
	_tmp7_ = _tmp2_;
	if (_tmp7_) {
		result = NULL;
		_g_object_unref0 (details);
		return result;
	}
	{
		FolksAvatarDetails* _tmp8_;
		GLoadableIcon* _tmp9_;
		GLoadableIcon* _tmp10_;
		GInputStream* _tmp11_ = NULL;
		GInputStream* stream;
		GInputStream* _tmp12_;
		GdkPixbuf* _tmp13_;
		GdkPixbuf* pixbuf;
		GdkPixbuf* _tmp14_;
		FolksAvatarDetails* _tmp15_;
		GLoadableIcon* _tmp16_;
		GLoadableIcon* _tmp17_;
		GtkMenuItem* _tmp18_ = NULL;
		_tmp8_ = details;
		_tmp9_ = folks_avatar_details_get_avatar (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_loadable_icon_load (_tmp10_, 48, NULL, NULL, &_inner_error_);
		stream = _tmp11_;
		if (_inner_error_ != NULL) {
			goto __catch19_g_error;
		}
		_tmp12_ = stream;
		_tmp13_ = gdk_pixbuf_new_from_stream_at_scale (_tmp12_, 48, 48, TRUE, NULL, &_inner_error_);
		pixbuf = _tmp13_;
		if (_inner_error_ != NULL) {
			_g_object_unref0 (stream);
			goto __catch19_g_error;
		}
		_tmp14_ = pixbuf;
		_tmp15_ = details;
		_tmp16_ = folks_avatar_details_get_avatar (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = contacts_avatar_menu_menu_item_for_pixbuf (self, _tmp14_, (GIcon*) _tmp17_);
		result = _tmp18_;
		_g_object_unref0 (pixbuf);
		_g_object_unref0 (stream);
		_g_object_unref0 (details);
		return result;
	}
	goto __finally19;
	__catch19_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally19:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (details);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = NULL;
	_g_object_unref0 (details);
	return result;
}


static GtkMenuItem* contacts_avatar_menu_menu_item_for_filename (ContactsAvatarMenu* self, const gchar* filename) {
	GtkMenuItem* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (filename != NULL, NULL);
	{
		const gchar* _tmp0_;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* pixbuf;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_ = NULL;
		GdkPixbuf* _tmp4_;
		const gchar* _tmp5_;
		GFile* _tmp6_ = NULL;
		GFile* _tmp7_;
		GFileIcon* _tmp8_;
		GFileIcon* _tmp9_;
		GtkMenuItem* _tmp10_ = NULL;
		GtkMenuItem* _tmp11_;
		_tmp0_ = filename;
		_tmp1_ = gdk_pixbuf_new_from_file (_tmp0_, &_inner_error_);
		pixbuf = _tmp1_;
		if (_inner_error_ != NULL) {
			goto __catch20_g_error;
		}
		_tmp2_ = pixbuf;
		_tmp3_ = gdk_pixbuf_scale_simple (_tmp2_, 48, 48, GDK_INTERP_HYPER);
		_g_object_unref0 (pixbuf);
		pixbuf = _tmp3_;
		_tmp4_ = pixbuf;
		_tmp5_ = filename;
		_tmp6_ = g_file_new_for_path (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = (GFileIcon*) g_file_icon_new (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = contacts_avatar_menu_menu_item_for_pixbuf (self, _tmp4_, (GIcon*) _tmp9_);
		_tmp11_ = _tmp10_;
		_g_object_unref0 (_tmp9_);
		_g_object_unref0 (_tmp7_);
		result = _tmp11_;
		_g_object_unref0 (pixbuf);
		return result;
	}
	goto __finally20;
	__catch20_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally20:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = NULL;
	return result;
}


static void contacts_avatar_menu_set_avatar_from_icon (ContactsAvatarMenu* self, GIcon* icon) {
	GIcon* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (icon != NULL);
	_tmp0_ = icon;
	g_signal_emit_by_name (self, "icon-set", _tmp0_);
}


static void contacts_avatar_menu_pick_avatar_cb (ContactsAvatarMenu* self, GtkMenuItem* menu) {
	GtkMenuItem* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	GIcon* _tmp2_;
	GIcon* icon;
	g_return_if_fail (self != NULL);
	g_return_if_fail (menu != NULL);
	_tmp0_ = menu;
	_tmp1_ = g_object_get_data ((GObject*) _tmp0_, "source-icon");
	_tmp2_ = _g_object_ref0 ((GIcon*) _tmp1_);
	icon = _tmp2_;
	contacts_avatar_menu_set_avatar_from_icon (self, icon);
	_g_object_unref0 (icon);
}


void contacts_avatar_menu_update_preview (ContactsAvatarMenu* self, GtkFileChooser* chooser) {
	GtkFileChooser* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* uri;
	const gchar* _tmp2_;
	GtkFileChooser* _tmp26_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (chooser != NULL);
	_tmp0_ = chooser;
	_tmp1_ = gtk_file_chooser_get_preview_uri (_tmp0_);
	uri = _tmp1_;
	_tmp2_ = uri;
	if (_tmp2_ != NULL) {
		GdkPixbuf* pixbuf;
		GtkFileChooser* _tmp3_;
		GtkWidget* _tmp4_ = NULL;
		GtkImage* _tmp5_;
		GtkImage* preview;
		const gchar* _tmp6_;
		GFile* _tmp7_ = NULL;
		GFile* file;
		GtkFileChooser* _tmp20_;
		GdkPixbuf* _tmp21_;
		GdkPixbuf* _tmp22_;
		pixbuf = NULL;
		_tmp3_ = chooser;
		_tmp4_ = gtk_file_chooser_get_preview_widget (_tmp3_);
		_tmp5_ = _g_object_ref0 (GTK_IS_IMAGE (_tmp4_) ? ((GtkImage*) _tmp4_) : NULL);
		preview = _tmp5_;
		_tmp6_ = uri;
		_tmp7_ = g_file_new_for_uri (_tmp6_);
		file = _tmp7_;
		{
			GFile* _tmp8_;
			GFileInfo* _tmp9_ = NULL;
			GFileInfo* file_info;
			GFileInfo* _tmp10_;
			_tmp8_ = file;
			_tmp9_ = g_file_query_info (_tmp8_, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
			file_info = _tmp9_;
			if (_inner_error_ != NULL) {
				goto __catch21_g_error;
			}
			_tmp10_ = file_info;
			if (_tmp10_ != NULL) {
				GFileInfo* _tmp11_;
				const gchar* _tmp12_ = NULL;
				gchar* _tmp13_;
				gchar* mime_type;
				const gchar* _tmp14_;
				_tmp11_ = file_info;
				_tmp12_ = g_file_info_get_content_type (_tmp11_);
				_tmp13_ = g_strdup (_tmp12_);
				mime_type = _tmp13_;
				_tmp14_ = mime_type;
				if (_tmp14_ != NULL) {
					GnomeDesktopThumbnailFactory* _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
					GdkPixbuf* _tmp18_ = NULL;
					GdkPixbuf* _tmp19_;
					_tmp15_ = self->priv->thumbnail_factory;
					_tmp16_ = uri;
					_tmp17_ = mime_type;
					_tmp18_ = gnome_desktop_thumbnail_factory_generate_thumbnail (_tmp15_, _tmp16_, _tmp17_);
					_tmp19_ = _g_object_ref0 (_tmp18_);
					_g_object_unref0 (pixbuf);
					pixbuf = _tmp19_;
				}
				_g_free0 (mime_type);
			}
			_g_object_unref0 (file_info);
		}
		goto __finally21;
		__catch21_g_error:
		{
			GError* e = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (e);
		}
		__finally21:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (file);
			_g_object_unref0 (preview);
			_g_object_unref0 (pixbuf);
			_g_free0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp20_ = chooser;
		_tmp21_ = pixbuf;
		gtk_dialog_set_response_sensitive (GTK_IS_DIALOG (_tmp20_) ? ((GtkDialog*) _tmp20_) : NULL, (gint) GTK_RESPONSE_ACCEPT, _tmp21_ != NULL);
		_tmp22_ = pixbuf;
		if (_tmp22_ != NULL) {
			GtkImage* _tmp23_;
			GdkPixbuf* _tmp24_;
			_tmp23_ = preview;
			_tmp24_ = pixbuf;
			gtk_image_set_from_pixbuf (_tmp23_, _tmp24_);
		} else {
			GtkImage* _tmp25_;
			_tmp25_ = preview;
			gtk_image_set_from_stock (_tmp25_, GTK_STOCK_DIALOG_QUESTION, GTK_ICON_SIZE_DIALOG);
		}
		_g_object_unref0 (file);
		_g_object_unref0 (preview);
		_g_object_unref0 (pixbuf);
	}
	_tmp26_ = chooser;
	gtk_file_chooser_set_preview_widget_active (_tmp26_, TRUE);
	_g_free0 (uri);
}


static Block27Data* block27_data_ref (Block27Data* _data27_) {
	g_atomic_int_inc (&_data27_->_ref_count_);
	return _data27_;
}


static void block27_data_unref (Block27Data* _data27_) {
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
		ContactsAvatarMenu * self;
		self = _data27_->self;
		_g_object_unref0 (_data27_->chooser);
		_g_object_unref0 (self);
		g_slice_free (Block27Data, _data27_);
	}
}


static void _contacts_avatar_menu_update_preview_gtk_file_chooser_update_preview (GtkFileChooser* _sender, gpointer self) {
	contacts_avatar_menu_update_preview (self, _sender);
}


static void __lambda32_ (Block27Data* _data27_, gint response) {
	ContactsAvatarMenu * self;
	gint _tmp0_;
	GtkFileChooserDialog* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_ = NULL;
	GFile* _tmp6_;
	GFileIcon* _tmp7_;
	GFileIcon* _tmp8_;
	GFileIcon* icon;
	GFileIcon* _tmp9_;
	GtkFileChooserDialog* _tmp10_;
	self = _data27_->self;
	_tmp0_ = response;
	if (_tmp0_ != ((gint) GTK_RESPONSE_ACCEPT)) {
		GtkFileChooserDialog* _tmp1_;
		_tmp1_ = _data27_->chooser;
		gtk_widget_destroy ((GtkWidget*) _tmp1_);
		return;
	}
	_tmp2_ = _data27_->chooser;
	_tmp3_ = gtk_file_chooser_get_uri ((GtkFileChooser*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_file_new_for_uri (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = (GFileIcon*) g_file_icon_new (_tmp6_);
	_tmp8_ = _tmp7_;
	_g_object_unref0 (_tmp6_);
	_g_free0 (_tmp4_);
	icon = _tmp8_;
	_tmp9_ = icon;
	contacts_avatar_menu_set_avatar_from_icon (self, (GIcon*) _tmp9_);
	_tmp10_ = _data27_->chooser;
	gtk_widget_destroy ((GtkWidget*) _tmp10_);
	_g_object_unref0 (icon);
}


static void ___lambda32__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self) {
	__lambda32_ (self, response_id);
}


static void contacts_avatar_menu_select_avatar_file_cb (ContactsAvatarMenu* self, GtkMenuItem* menu) {
	Block27Data* _data27_;
	const gchar* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	GtkFileChooserDialog* _tmp2_;
	GtkFileChooserDialog* _tmp3_;
	GtkFileChooserDialog* _tmp4_;
	GtkFileChooserDialog* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* preview;
	GtkImage* _tmp8_;
	GtkFileChooserDialog* _tmp9_;
	GtkImage* _tmp10_;
	GtkFileChooserDialog* _tmp11_;
	GtkImage* _tmp12_;
	GtkFileChooserDialog* _tmp13_;
	const gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	gchar* folder;
	const gchar* _tmp16_;
	GtkFileChooserDialog* _tmp19_;
	GtkFileChooserDialog* _tmp20_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (menu != NULL);
	_data27_ = g_slice_new0 (Block27Data);
	_data27_->_ref_count_ = 1;
	_data27_->self = g_object_ref (self);
	_tmp0_ = _ ("Browse for more pictures");
	_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp2_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_tmp0_, GTK_WINDOW (_tmp1_), GTK_FILE_CHOOSER_ACTION_OPEN, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);
	_tmp3_ = g_object_ref_sink (_tmp2_);
	_data27_->chooser = _tmp3_;
	_tmp4_ = _data27_->chooser;
	gtk_window_set_modal ((GtkWindow*) _tmp4_, TRUE);
	_tmp5_ = _data27_->chooser;
	gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp5_, FALSE);
	_tmp6_ = (GtkImage*) gtk_image_new ();
	_tmp7_ = g_object_ref_sink (_tmp6_);
	preview = _tmp7_;
	_tmp8_ = preview;
	gtk_widget_set_size_request ((GtkWidget*) _tmp8_, 128, -1);
	_tmp9_ = _data27_->chooser;
	_tmp10_ = preview;
	gtk_file_chooser_set_preview_widget ((GtkFileChooser*) _tmp9_, (GtkWidget*) _tmp10_);
	_tmp11_ = _data27_->chooser;
	gtk_file_chooser_set_use_preview_label ((GtkFileChooser*) _tmp11_, FALSE);
	_tmp12_ = preview;
	gtk_widget_show ((GtkWidget*) _tmp12_);
	_tmp13_ = _data27_->chooser;
	g_signal_connect_object ((GtkFileChooser*) _tmp13_, "update-preview", (GCallback) _contacts_avatar_menu_update_preview_gtk_file_chooser_update_preview, self, 0);
	_tmp14_ = g_get_user_special_dir (G_USER_DIRECTORY_PICTURES);
	_tmp15_ = g_strdup (_tmp14_);
	folder = _tmp15_;
	_tmp16_ = folder;
	if (_tmp16_ != NULL) {
		GtkFileChooserDialog* _tmp17_;
		const gchar* _tmp18_;
		_tmp17_ = _data27_->chooser;
		_tmp18_ = folder;
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp17_, _tmp18_);
	}
	_tmp19_ = _data27_->chooser;
	g_signal_connect_data ((GtkDialog*) _tmp19_, "response", (GCallback) ___lambda32__gtk_dialog_response, block27_data_ref (_data27_), (GClosureNotify) block27_data_unref, 0);
	_tmp20_ = _data27_->chooser;
	gtk_window_present ((GtkWindow*) _tmp20_);
	_g_free0 (folder);
	_g_object_unref0 (preview);
	block27_data_unref (_data27_);
	_data27_ = NULL;
}


static void _contacts_avatar_menu_pick_avatar_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	contacts_avatar_menu_pick_avatar_cb (self, _sender);
}


static gchar** _vala_array_dup5 (gchar** self, int length) {
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


static void _contacts_avatar_menu_select_avatar_file_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	contacts_avatar_menu_select_avatar_file_cb (self, _sender);
}


ContactsAvatarMenu* contacts_avatar_menu_construct (GType object_type, ContactsContact* contact) {
	ContactsAvatarMenu * self = NULL;
	GnomeDesktopThumbnailFactory* _tmp0_;
	GtkStyleContext* _tmp1_ = NULL;
	gint x;
	gint y;
	static const gint COLUMNS = 5;
	gchar** _tmp24_;
	gchar** _tmp25_ = NULL;
	gchar** _tmp26_;
	gint _tmp26__length1;
	gchar** system_data_dirs;
	gint system_data_dirs_length1;
	gint _system_data_dirs_size_;
	gchar** _tmp27_;
	gint _tmp27__length1;
	const gchar* _tmp54_ = NULL;
	GtkMenuItem* _tmp55_ = NULL;
	GtkMenuItem* _tmp56_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (contact != NULL, NULL);
	self = (ContactsAvatarMenu*) g_object_new (object_type, NULL);
	_tmp0_ = gnome_desktop_thumbnail_factory_new (GNOME_DESKTOP_THUMBNAIL_SIZE_NORMAL);
	_g_object_unref0 (self->priv->thumbnail_factory);
	self->priv->thumbnail_factory = _tmp0_;
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp1_, "contact-frame-menu");
	x = 0;
	y = 0;
	{
		ContactsContact* _tmp2_;
		FolksIndividual* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeIterator* _tmp6_ = NULL;
		GeeIterator* _p_it;
		_tmp2_ = contact;
		_tmp3_ = _tmp2_->individual;
		_tmp4_ = folks_individual_get_personas (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
		_p_it = _tmp6_;
		while (TRUE) {
			GeeIterator* _tmp7_;
			gboolean _tmp8_ = FALSE;
			GeeIterator* _tmp9_;
			gpointer _tmp10_ = NULL;
			FolksPersona* p;
			FolksPersona* _tmp11_;
			GtkMenuItem* _tmp12_ = NULL;
			GtkMenuItem* menuitem;
			GtkMenuItem* _tmp13_;
			_tmp7_ = _p_it;
			_tmp8_ = gee_iterator_next (_tmp7_);
			if (!_tmp8_) {
				break;
			}
			_tmp9_ = _p_it;
			_tmp10_ = gee_iterator_get (_tmp9_);
			p = (FolksPersona*) _tmp10_;
			_tmp11_ = p;
			_tmp12_ = contacts_avatar_menu_menu_item_for_persona (self, _tmp11_);
			menuitem = _tmp12_;
			_tmp13_ = menuitem;
			if (_tmp13_ != NULL) {
				GtkMenuItem* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				GtkMenuItem* _tmp19_;
				GtkMenuItem* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				_tmp14_ = menuitem;
				_tmp15_ = x;
				_tmp16_ = x;
				_tmp17_ = y;
				_tmp18_ = y;
				gtk_menu_attach ((GtkMenu*) self, (GtkWidget*) _tmp14_, (guint) _tmp15_, (guint) (_tmp16_ + 1), (guint) _tmp17_, (guint) (_tmp18_ + 1));
				_tmp19_ = menuitem;
				gtk_widget_show ((GtkWidget*) _tmp19_);
				_tmp20_ = menuitem;
				g_signal_connect_object (_tmp20_, "activate", (GCallback) _contacts_avatar_menu_pick_avatar_cb_gtk_menu_item_activate, self, 0);
				_tmp21_ = x;
				x = _tmp21_ + 1;
				_tmp22_ = x;
				if (_tmp22_ >= COLUMNS) {
					gint _tmp23_;
					_tmp23_ = y;
					y = _tmp23_ + 1;
					x = 0;
				}
			}
			_g_object_unref0 (menuitem);
			_g_object_unref0 (p);
		}
		_g_object_unref0 (_p_it);
	}
	_tmp25_ = _tmp24_ = g_get_system_data_dirs ();
	_tmp26_ = (_tmp25_ != NULL) ? _vala_array_dup5 (_tmp25_, _vala_array_length (_tmp24_)) : ((gpointer) _tmp25_);
	_tmp26__length1 = _vala_array_length (_tmp24_);
	system_data_dirs = _tmp26_;
	system_data_dirs_length1 = _tmp26__length1;
	_system_data_dirs_size_ = system_data_dirs_length1;
	_tmp27_ = system_data_dirs;
	_tmp27__length1 = system_data_dirs_length1;
	{
		gchar** data_dir_collection = NULL;
		gint data_dir_collection_length1 = 0;
		gint _data_dir_collection_size_ = 0;
		gint data_dir_it = 0;
		data_dir_collection = _tmp27_;
		data_dir_collection_length1 = _tmp27__length1;
		for (data_dir_it = 0; data_dir_it < _tmp27__length1; data_dir_it = data_dir_it + 1) {
			gchar* _tmp28_;
			gchar* data_dir = NULL;
			_tmp28_ = g_strdup (data_dir_collection[data_dir_it]);
			data_dir = _tmp28_;
			{
				const gchar* _tmp29_;
				gchar* _tmp30_ = NULL;
				gchar* path;
				GDir* dir;
				GDir* _tmp34_;
				_tmp29_ = data_dir;
				_tmp30_ = g_build_filename (_tmp29_, "pixmaps", "faces", NULL);
				path = _tmp30_;
				dir = NULL;
				{
					const gchar* _tmp31_;
					GDir* _tmp32_ = NULL;
					GDir* _tmp33_;
					_tmp31_ = path;
					_tmp32_ = g_dir_open (_tmp31_, (guint) 0, &_inner_error_);
					_tmp33_ = _tmp32_;
					if (_inner_error_ != NULL) {
						goto __catch22_g_error;
					}
					_g_dir_close0 (dir);
					dir = _tmp33_;
				}
				goto __finally22;
				__catch22_g_error:
				{
					g_clear_error (&_inner_error_);
					_inner_error_ = NULL;
				}
				__finally22:
				if (_inner_error_ != NULL) {
					_g_dir_close0 (dir);
					_g_free0 (path);
					_g_free0 (data_dir);
					system_data_dirs = (_vala_array_free (system_data_dirs, system_data_dirs_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
				_tmp34_ = dir;
				if (_tmp34_ != NULL) {
					gchar* face = NULL;
					while (TRUE) {
						GDir* _tmp35_;
						const gchar* _tmp36_ = NULL;
						gchar* _tmp37_;
						const gchar* _tmp38_;
						const gchar* _tmp39_;
						const gchar* _tmp40_;
						gchar* _tmp41_ = NULL;
						gchar* filename;
						const gchar* _tmp42_;
						GtkMenuItem* _tmp43_ = NULL;
						GtkMenuItem* menuitem;
						GtkMenuItem* _tmp44_;
						gint _tmp45_;
						gint _tmp46_;
						gint _tmp47_;
						gint _tmp48_;
						GtkMenuItem* _tmp49_;
						GtkMenuItem* _tmp50_;
						gint _tmp51_;
						gint _tmp52_;
						_tmp35_ = dir;
						_tmp36_ = g_dir_read_name (_tmp35_);
						_tmp37_ = g_strdup (_tmp36_);
						_g_free0 (face);
						face = _tmp37_;
						_tmp38_ = face;
						if (!(_tmp38_ != NULL)) {
							break;
						}
						_tmp39_ = path;
						_tmp40_ = face;
						_tmp41_ = g_build_filename (_tmp39_, _tmp40_, NULL);
						filename = _tmp41_;
						_tmp42_ = filename;
						_tmp43_ = contacts_avatar_menu_menu_item_for_filename (self, _tmp42_);
						menuitem = _tmp43_;
						_tmp44_ = menuitem;
						_tmp45_ = x;
						_tmp46_ = x;
						_tmp47_ = y;
						_tmp48_ = y;
						gtk_menu_attach ((GtkMenu*) self, (GtkWidget*) _tmp44_, (guint) _tmp45_, (guint) (_tmp46_ + 1), (guint) _tmp47_, (guint) (_tmp48_ + 1));
						_tmp49_ = menuitem;
						gtk_widget_show ((GtkWidget*) _tmp49_);
						_tmp50_ = menuitem;
						g_signal_connect_object (_tmp50_, "activate", (GCallback) _contacts_avatar_menu_pick_avatar_cb_gtk_menu_item_activate, self, 0);
						_tmp51_ = x;
						x = _tmp51_ + 1;
						_tmp52_ = x;
						if (_tmp52_ >= COLUMNS) {
							gint _tmp53_;
							_tmp53_ = y;
							y = _tmp53_ + 1;
							x = 0;
						}
						_g_object_unref0 (menuitem);
						_g_free0 (filename);
					}
					_g_free0 (face);
				}
				_g_dir_close0 (dir);
				_g_free0 (path);
				_g_free0 (data_dir);
			}
		}
	}
	_tmp54_ = _ ("Browse for more pictures...");
	_tmp55_ = contacts_utils_add_menu_item ((GtkMenu*) self, _tmp54_);
	_tmp56_ = _tmp55_;
	g_signal_connect_object (_tmp56_, "activate", (GCallback) _contacts_avatar_menu_select_avatar_file_cb_gtk_menu_item_activate, self, 0);
	_g_object_unref0 (_tmp56_);
	system_data_dirs = (_vala_array_free (system_data_dirs, system_data_dirs_length1, (GDestroyNotify) g_free), NULL);
	return self;
}


ContactsAvatarMenu* contacts_avatar_menu_new (ContactsContact* contact) {
	return contacts_avatar_menu_construct (CONTACTS_TYPE_AVATAR_MENU, contact);
}


static void contacts_avatar_menu_class_init (ContactsAvatarMenuClass * klass) {
	contacts_avatar_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ContactsAvatarMenuPrivate));
	G_OBJECT_CLASS (klass)->finalize = contacts_avatar_menu_finalize;
	g_signal_new ("icon_set", CONTACTS_TYPE_AVATAR_MENU, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_ICON);
}


static void contacts_avatar_menu_instance_init (ContactsAvatarMenu * self) {
	self->priv = CONTACTS_AVATAR_MENU_GET_PRIVATE (self);
}


static void contacts_avatar_menu_finalize (GObject* obj) {
	ContactsAvatarMenu * self;
	self = CONTACTS_AVATAR_MENU (obj);
	_g_object_unref0 (self->priv->thumbnail_factory);
	G_OBJECT_CLASS (contacts_avatar_menu_parent_class)->finalize (obj);
}


GType contacts_avatar_menu_get_type (void) {
	static volatile gsize contacts_avatar_menu_type_id__volatile = 0;
	if (g_once_init_enter (&contacts_avatar_menu_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContactsAvatarMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_avatar_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsAvatarMenu), 0, (GInstanceInitFunc) contacts_avatar_menu_instance_init, NULL };
		GType contacts_avatar_menu_type_id;
		contacts_avatar_menu_type_id = g_type_register_static (GTK_TYPE_MENU, "ContactsAvatarMenu", &g_define_type_info, 0);
		g_once_init_leave (&contacts_avatar_menu_type_id__volatile, contacts_avatar_menu_type_id);
	}
	return contacts_avatar_menu_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



